Bug 323621 - broken debuginfo for vDSO32 (for i386-on-x86_64)
broken debuginfo for vDSO32 (for i386-on-x86_64)
Status: CLOSED WORKSFORME
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
rawhide
x86_64 Linux
low Severity low
: ---
: ---
Assigned To: Red Hat Kernel Manager
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-10-08 15:30 EDT by Jan Kratochvil
Modified: 2007-11-30 17:12 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-10-08 17:30:42 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jan Kratochvil 2007-10-08 15:30:08 EDT
Description of problem:
Roland had a correct objection GDB does not resolve vDSO32 symbols:
(gdb) i line *0xffffe410
No line number information available for address
  0xffffe410 <__kernel_vsyscall+16>
The .debug_info section of vdso32-sysenter.so.debug looks to be cut.

Version-Release number of selected component (if applicable):
kernel-2.6.23-0.222.rc9.git4.fc8.x86_64
for the verifications I used:
binutils-2.17.50.0.18-1.x86_64
elfutils-0.129-2.fc8.x86_64
gdb-6.6-30.fc8.x86_64

How reproducible:
Always.

Steps to Reproduce:
1. ls -l /usr/lib/debug/lib/modules/`uname -r`/vdso/vdso32-sysenter.so.debug
2. readelf -a --debug-dump=info /usr/lib/debug/lib/modules/`uname
-r`/vdso/vdso32-sysenter.so.debug

Actual results:
-rwxr-xr-x 1 root root 2304 2007-10-06 19:44
/usr/lib/debug/lib/modules/2.6.23-0.222.rc9.git4.fc8/vdso/vdso32-sysenter.so.debug*

Section Headers:
  [Nr] Name              Type            Addr     Off    Size   ES Flg Lk Inf Al
  [15] .debug_info       PROGBITS        00000000 000196 000087 00      0   0  1
...
The section .debug_info contains:

  Compilation Unit @ offset 0x0:
   Length:        131
   Version:       2
   Abbrev Offset: 0
   Pointer Size:  4
 <0><b>: Abbrev Number: 1 (DW_TAG_compile_unit)
  < c>     DW_AT_stmt_list   : 0        
  <10>     DW_AT_ranges      : 0        
  <14>     DW_AT_name        : arch/x86_64/ia32/vsyscall-sysenter.S     
  <39>     DW_AT_comp_dir    :
/usr/src/debug////////kernel-2.6.22/linux-2.6.22.x86_64  
  <71>     DW_AT_producer    : GNU AS 2.17.50.0.18      
  <85>     DW_AT_language    : 32769    (MIPS assembler)


Notes at offset 0x000000c0 with length 0x0000003c:
...

Expected results:
It should be longer.

Additional info:
Comment 1 Roland McGrath 2007-10-08 17:23:45 EDT
That's all it should have for an assembly file.  .debug_line and .debug_ranges
have all the info.
Comment 2 Roland McGrath 2007-10-08 17:30:42 EDT
-bash-3.2$ eu-addr2line -e
/lib/modules/2.6.23-0.222.rc9.git4.fc8/vdso/vdso32-sysenter.so 0xffffe410
arch/x86_64/ia32/vsyscall-sysenter.S:26
-bash-3.2$ 


Note You need to log in before you can comment on or make changes to this bug.